var similarweb_CommonUtils = 
{
	//----------------------Constants for rollDate()
	get dtMONTH() { return 0; },
	get dtDAY()   { return 1; },
	get dtYEAR()  { return 2; },

	// Rolling Date to some years/month/days forward or backward 
    // DateType is set {dtYEAR,dtMONTH,dtDAY}
	rollDate : function (date, count, dateType) 
	{
		try 
		{
			var yr = date.getFullYear();
			var mo = date.getMonth() + 1;
			var day = date.getDate();
			
			var hours = date.getHours();
			var minutes = date.getMinutes();
			var seconds = date.getSeconds();
			var milliseconds = date.getMilliseconds();

			var _dateType = this.dtMONTH;
			if (dateType) 
			{
				if ((dateType == this.dtMONTH) || (dateType == this.dtDAY) || (dateType == this.dtYEAR)) 
				{
					_dateType = dateType;
				}
			}
			
			if (_dateType == this.dtYEAR) yr = yr + count;
			if (_dateType == this.dtMONTH) mo = mo + count;
			if (_dateType == this.dtDAY) day = day + count;
		
			return new Date(yr, mo-1, day, hours, minutes, seconds, milliseconds);
		} 
		catch (e) 
		{
			alert(e);
		}
	},

	// Convert Date to String in format: "yyyy-mm-dd HH:MM:SS"
	getDateText: function(d) 
	{		
		var year = d.getFullYear();
		var month = (d.getMonth() < 9 ? '0' : '') + (d.getMonth() + 1);
		var day = (d.getDate() < 10 ? '0' : '') + d.getDate(); 
		var hh =  (d.getHours() < 10 ? '0' : '') + d.getHours();
		var mm =  (d.getMinutes() < 10 ? '0' : '') + d.getMinutes();
		var ss =  (d.getSeconds() < 10 ? '0' : '') + d.getSeconds();
		return  year +"-"+ month +"-"+ day +" "+ hh +":"+ mm +":"+ ss;
	},
};