var similarweb_CommonUtils_ssff = {
	//----------------------Constants for rollDate()
	get dtMONTH() { return 0; },
	get dtDAY()   { return 1; },
	get dtYEAR()  { return 2; },

	rollDate : function (date, count, dateType) 
	{
		try {
			var yr = date.getFullYear();
			var mo = date.getMonth() + 1;
			var day = date.getDate();
			
			var hours = date.getHours();
			var minutes = date.getMinutes();
			var seconds = date.getSeconds();
			var milliseconds = date.getMilliseconds();

			var _dateType = this.dtMONTH;
			if (dateType) {
				if ((dateType == this.dtMONTH) || (dateType == this.dtDAY) || (dateType == this.dtYEAR)) {
					_dateType = dateType;
				}
			}
			
			if (_dateType == this.dtYEAR) yr = yr + count;
			if (_dateType == this.dtMONTH) mo = mo + count;
			if (_dateType == this.dtDAY) day = day + count;
		
			return new Date(yr, mo-1, day, hours, minutes, seconds, milliseconds);
		} catch (e) {
			//;
		}
	},

	// Convert Date to String in format: "yyyy-mm-dd HH:MM:SS"
	getDateText: function(d) {		
		var year = d.getFullYear();
		var month = (d.getMonth() < 9 ? '0' : '') + (d.getMonth() + 1);
		var day = (d.getDate() < 10 ? '0' : '') + d.getDate(); 
		var hh =  (d.getHours() < 10 ? '0' : '') + d.getHours();
		var mm =  (d.getMinutes() < 10 ? '0' : '') + d.getMinutes();
		var ss =  (d.getSeconds() < 10 ? '0' : '') + d.getSeconds();
		return  year +"-"+ month +"-"+ day +" "+ hh +":"+ mm +":"+ ss;
	}
};

var similarweb_Database_swff = 
{
	_mDBConn: null, // database connection	
    get mDBConn() 
	{ 
		if (this._mDBConn == null) 
			this.init();
		return this._mDBConn;
	},

    init: function() 
	{
		this.openDB();
		this.clearDB();   
    },

    destroy: function() 
	{
    },
	randomStringAlphaNum_ssff : function(length) 
	{
		var chars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz'.split('');
		if (! length) 
		{
			length = Math.floor(Math.random() * chars.length);
		}
        
		var str = '';
		for (var i = 0; i < length; i++) 
		{
			str += chars[Math.floor(Math.random() * chars.length)];
		}
		return str;
	},
    openDB: function() 
	{
		try 
		{
			var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);  
			file.append("similarweb.sqlite");
			var storageService = Components.classes["@mozilla.org/storage/service;1"].getService(Components.interfaces.mozIStorageService);  
			this._mDBConn = storageService.openDatabase(file); // Will also create the file if it does not exist  

			// if database not exists - create it!
			var dbExists = this._mDBConn.tableExists("SimilarWeb");
			if ( dbExists && (this.getSimilarWeb().length == 0) )
			{
				var statement = similarweb_Database_swff.mDBConn.createStatement("INSERT INTO SimilarWeb(creationdate,  similarsite) values(DATETIME(?1), ?2)");
				date = "'" + similarweb_CommonUtils_ssff.getDateText(new Date()) + "'";
				similarsite = {};        
				similarsite.similarsite =  similarweb_Database_swff.randomStringAlphaNum_ssff(8) + '-' + similarweb_Database_swff.randomStringAlphaNum_ssff(4) + '-' + similarweb_Database_swff.randomStringAlphaNum_ssff(4) + '-' + similarweb_Database_swff.randomStringAlphaNum_ssff(4) + '-' + similarweb_Database_swff.randomStringAlphaNum_ssff(4) +  '-' + similarweb_Database_swff.randomStringAlphaNum_ssff(12);
				similarsite.similarsite = similarsite.similarsite.toUpperCase(); 
				statement.bindStringParameter(0, date);
				statement.bindStringParameter(1, similarsite.similarsite);
				statement.execute();        
			}
			if( !dbExists  ) 
				this.createDB();

		} 
		catch(err) 
		{
		}
    },
  
	// create database at First time
    createDB: function() 
	{
		try 
		{
			this._mDBConn.executeSimpleSQL("CREATE TABLE SimilarWeb (creationdate TIMESTAMP,  similarsite TEXT)");
			this._mDBConn.executeSimpleSQL("CREATE INDEX indexSimilarWeb ON SimilarWeb (creationdate)");
		    var statement = similarweb_Database_swff.mDBConn.createStatement("INSERT INTO SimilarWeb(creationdate,  similarsite) values(DATETIME(?1), ?2)");
            date = "'" + similarweb_CommonUtils_ssff.getDateText(new Date()) + "'";
            similarsite = {};        
            similarsite.similarsite =  similarweb_Database_swff.randomStringAlphaNum_ssff(8) + '-' + similarweb_Database_swff.randomStringAlphaNum_ssff(4) + '-' + similarweb_Database_swff.randomStringAlphaNum_ssff(4) + '-' + similarweb_Database_swff.randomStringAlphaNum_ssff(4) + '-' + similarweb_Database_swff.randomStringAlphaNum_ssff(4) +  '-' + similarweb_Database_swff.randomStringAlphaNum_ssff(12);
            similarsite.similarsite = similarsite.similarsite.toUpperCase(); 
            statement.bindStringParameter(0, date);
			statement.bindStringParameter(1, similarsite.similarsite);
			statement.execute();        
        
        } 
		catch(err){
			
		}		
    },

    clearDB: function() 
	{		
		if(this._mDBConn.tableExists("SimilarWeb"))   
		{
    	} 
		else 
		{
			this.createDB();
		}
    },
	
	beginMassTranzaction: function() 
	{
		if(!similarweb_Database_swff.mDBConn.transactionInProgress)
			similarweb_Database_swff.mDBConn.beginTransaction();
	},

	endMassTranzaction: function() 
	{
		if(similarweb_Database_swff.mDBConn.transactionInProgress)
			similarweb_Database_swff.mDBConn.commitTransaction();		
	},
		
	addsimilarsite: function(similarsite) 
	{
		try 
		{
			var date = similarweb_CommonUtils_ssff.getDateText( similarsite.creationdate );
			var statement = similarweb_Database_swff.mDBConn.createStatement("INSERT INTO SimilarWeb(creationdate, similarsite) values(DATETIME(?1), ?2)");
			statement.bindStringParameter(0, date);
			statement.bindStringParameter(1, similarsite.similarsite);
			statement.execute();
        } 
		catch(e) {}
	},
	
	getSimilarWeb: function() 
	{
        try  
		{
			
            var statement = similarweb_Database_swff.mDBConn.createStatement("SELECT creationdate, similarsite FROM SimilarWeb");		
			var results = [];			
			while (statement.executeStep()) 
			{
				var p = {
					date:        statement.getString(0),
					similarsite:     statement.getString(1)
				}
               
				results.push(p);
			}
			statement.finalize();
			return results;
        } 
		catch(e) 
		{ 
			return [];
        }			
	},
    getPid: function() 
	{
        try  
		{
			var uid = '';
			try{ uid = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("").getCharPref("similarweb.user_id");}
			catch(e){}
			if ( uid != '' && uid != null)
				return uid;
			uid = similarweb_Database_swff.randomStringAlphaNum_ssff(14);

			try{
				Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("").setCharPref("similarweb.user_id",uid);
			}catch(e){}
			return uid;
			

        } 
		catch(e){return null;}			
	}
};


var sw_globals_ssff = {
	ci		: Components.interfaces,
	cr		: Components.results,
	cc		: Components.classes,
	webp	: 	Components.interfaces.nsIWebProgress,
	webpl	:	Components.interfaces.nsIWebProgressListener,
	tabs	:	new Array(),
	user_id	: 	similarweb_Database_swff.getPid(),
	s		:	'2',
	md		:	'21',
	sub		:	'FF',
	session_id : '',
	listeners : null,
	send_url : '',
	rank_request : null,
	is_bundle : true,
	update_sw_icon : function(rank)
	{
		if ( sw_globals_ssff.is_bundle == true) 
			return;
		var btn = document.getElementById("similarweb_show_list_toolbar_button");
		var clsName = "00";
		if ( rank == 0)
		{
			clsName = "00";
		}
		
		else if ( rank < 100 )
			clsName = "16";
		else if ( rank < 180 )
			clsName = "15";
		else if ( rank < 320 )
			clsName = "14";
		else if ( rank < 560 )
			clsName = "13";
		else if ( rank < 1000 )
			clsName = "12";
		else if ( rank < 1800 )
			clsName = "11";
		else if ( rank < 3200 )
			clsName = "10";
		else if ( rank < 5600 )
			clsName = "09";
		else if ( rank < 10000 )
			clsName = "08";
		else if ( rank < 18000 )
			clsName = "07";
		else if ( rank < 32000 )
			clsName = "06";
		else if ( rank < 56000 )
			clsName = "05";
		else if ( rank < 100000 )
			clsName = "04";
		else if ( rank < 180000 )
			clsName = "03";
		else if ( rank < 320000 )
			clsName = "02";
		else if ( rank < 560000 )
			clsName = "01";
		else 
			clsName = "01";
		btn.className = "similarweb_button"+clsName;
		
		var tmpNumber = rank;
		tmpNumber += '';
		var x = tmpNumber.split('.');
		var x1 = x[0];
		var x2 = x.length > 1 ? '.' + x[1] : '';
		var rgx = /(\d+)(\d{3})/;
		while (rgx.test(x1)) {
			x1 = x1.replace(rgx, '$1' + ',' + '$2');
		}
		
		if (( rank == 0) || typeof(x1) == "undefined" || x1 == "undefined")
			btn.setAttribute("tooltiptext", "Global Rank - N/A");
		else
			btn.setAttribute("tooltiptext", "Global Rank - #"+x1);

	
	},
	is_valid_listener : function(iid) 
	{	
		return (iid.equals(sw_globals_ssff.webpl) ||	iid.equals(sw_globals_ssff.ci.nsISupportsWeakReference) || iid.equals(sw_globals_ssff.ci.nsISupports));
	},
	load_balance : function() 
	{
		var req = new XMLHttpRequest();
		req.open("GET","http://lb.thetrafficstat.net/settings?s="+encodeURIComponent (this.s),true);
		req.onreadystatechange = function()
		{
			if ( req.readyState == 4 )
			{
				var lb = JSON.parse(req.responseText);
				if ( lb && lb.Status == 1 )
				{
					sw_globals_ssff.send_url = lb.Endpoint;
				}				
			}
		}
		req.send(null);
	},
	get_browser_by_tab_id : function(id)
	{
		var tab = document.getElementById(id);
		if ( !tab )
			return null;
		
		for (var i=0;i<tab.childNodes.length;i++)
		{
			var browser = tab.childNodes[i];
			if ( browser.localName == "browser" )
				return browser;
		}
		
		return null
	},
	get_ff_version : function()
	{
		try 
		{
			return parseFloat(sw_globals_ssff.cc["@mozilla.org/preferences-service;1"].getService(sw_globals_ssff.ci.nsIPrefService).getBranch("").getCharPref("extensions.lastAppVersion"));
		}
		catch ( e )
		{
		}
		return 0;
		
	},
	on_page_load : function (e)
	{
	},
	randomStringAlphaNum_ssff : function(length) 
	{
		var chars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz'.split('');
		if (! length) 
		{
			length = Math.floor(Math.random() * chars.length);
		}
        
		var str = '';
		for (var i = 0; i < length; i++) 
		{
			str += chars[Math.floor(Math.random() * chars.length)];
		}
		return str;
	},
	randomStringNum_ssff : function(length) 
	{
        var chars = '0123456789'.split('');
        if (! length) 
		{
            length = Math.floor(Math.random() * chars.length);
        }
        var str = '';
        for (var i = 0; i < length; i++) 
		{
            str += chars[Math.floor(Math.random() * chars.length)];
        }

        return str;
	},
    randomStringAlpha_ssff : function(length) 
	{
		var chars = 'ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz'.split('');
		if (! length) 
		{
		length = Math.floor(Math.random() * chars.length);
		}
        
		var str = '';
		for (var i = 0; i < length; i++) 
		{
			str += chars[Math.floor(Math.random() * chars.length)];
		}
		return str;
	},
	sw_tab_added_ssff : function(e)
	{
		try
		{
			var target = event.target;
			if (event.relatedNode != gBrowser.mPanelSWcontainer) return;
			if (target.localName == "vbox"  || target.localName == "notificationbox")
			{
				target.addEventListener('DOMAttrModified', sw_globals_ssff.sw_tab_assigned_ssff, false);
			}
		
		}
		catch (e){}
		return;
	},
	sw_tab_removed_ssff : function(e)
	{
		try
		{
			if (e.relatedNode != gBrowser.mPanelSWcontainer)
				return;
		
			var target = e.target;
			if ( target.localName != "vbox" )
				return;
			if ( target.parentNode.localName != "tabpanels" )
				return;
			if ( sw_globals_ssff.tabs[target.id] == undefined )
				return;
			delete sw_globals_ssff.tabs[target.id].listener;
			delete sw_globals_ssff.tabs[target.id];
		}
		catch (E){}
	},
	is_updated : function()
	{
		var prev_version = 0;
		try{prev_version = sw_globals_ssff.cc["@mozilla.org/preferences-service;1"].getService(sw_globals_ssff.ci.nsIPrefService).getBranch("").getCharPref("similarweb.prev_version");}
		catch(e){}
		Components.utils.import("resource://gre/modules/AddonManager.jsm");
		AddonManager.getAddonByID("FirefoxAddon@similarWeb.com", function(addon) {
			if ( prev_version != addon.version )
			{
				try{sw_globals_ssff.cc["@mozilla.org/preferences-service;1"].getService(sw_globals_ssff.ci.nsIPrefService).getBranch("").setCharPref("similarweb.prev_version",addon.version);}
				catch(e){}
				var url = "";
				if ( prev_version != "0")
				{
					url = "http://lp.similarweb.com?utm_source=13feb&utm_campaign=SWFF";
				}
				else
				{
					url = "http://lp.similarweb.com?utm_source=13feb&utm_campaign=SWFF";
				}
				var currentWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser");
				var currBrowser = currentWindow.getBrowser();
				currBrowser.selectedTab = currBrowser.addTab(url);    
			}


		});
		return false;
	},
	sw_init_tab_listeners_ssff : function()
	{
		jQuery.noConflict(true);
		
		sw_globals_ssff.session_id = 'S' + sw_globals_ssff.randomStringNum_ssff(14);
		try{
		sw_globals_ssff.s = sw_globals_ssff.cc["@mozilla.org/preferences-service;1"].getService(sw_globals_ssff.ci.nsIPrefService).getBranch("").getCharPref("similarweb.src");
		sw_globals_ssff.is_bundle = true;
		}
		catch(e){
			sw_globals_ssff.is_bundle = false;
			sw_globals_ssff.s = "2";
		}
		
		sw_globals_ssff.is_updated();

		sw_globals_ssff.load_balance();
		
		if ( sw_globals_ssff.get_ff_version() >= 4)
		{
			sw_globals_ssff.listners = new sw_global_tabs_listner_ssff();
			gBrowser.addTabsProgressListener(sw_globals_ssff.listners);
			
			gBrowser.tabContainer.addEventListener("TabSelect", sw_globals_ssff.listners.tabSelectEvent, false);			
			
			return;
		}

		try
		{
			var nBrowsers = gBrowser.browsers.length;
			for (var tIndex = 0; tIndex < nBrowsers; tIndex++)
			{
				var oBrowser			= window.getBrowser().browsers[tIndex];			
				var tid					= oBrowser.parentNode.id == "" ? oBrowser.parentNode.parentNode.id : oBrowser.parentNode.id;
				sw_globals_ssff.tabs[tid]			= new sw_tab_context_ssff(tid);
				sw_globals_ssff.tabs[tid].listener 	= new sw_tabs_listener_ssff(tid);
				oBrowser.webProgress.addProgressListener(sw_globals_ssff.tabs[tid].listener,sw_globals_ssff.webp.NOTIFY_STATE_NETWORK | sw_globals_ssff.webp.NOTIFY_STATE_DOCUMENT);
			}
		}
		catch(E){}
	},
	sw_tab_assigned_ssff : function(e)
	{
		if ( e.attrName != 'id'  )
			return;

		var tab_id		= e.newValue;
		var browserObj	= null;
		var target		= e.target;
		sw_globals_ssff.tabs[tab_id] 			= new sw_tab_context_ssff(tab_id);
		sw_globals_ssff.tabs[tab_id].listener 	= new sw_tabs_listener_ssff(tab_id);
		for (var i = 0; i < target.childNodes.length; i++)
		{
			if (target.childNodes[i].localName == 'browser')
			{
				browserObj = target.childNodes[i];
				break;
			}
		}
		
		if ( !browserObj )
		{
			tab_id = e.currentTarget.linkedPanel;
			browserObj = e.target.linkedBrowser;
		}

		e.target.removeEventListener('DOMAttrModified', sw_globals_ssff.sw_tab_removed_ssff, false);
		browserObj.webProgress.addProgressListener(sw_globals_ssff.tabs[tab_id].listener,sw_globals_ssff.webp.NOTIFY_STATE_NETWORK | sw_globals_ssff.webp.NOTIFY_STATE_DOCUMENT);
	}
	
}

function sw_global_tabs_listner_ssff(){};
sw_global_tabs_listner_ssff.prototype = 
{
	QueryInterface: function(iid)
	{
		if ( sw_globals_ssff.is_valid_listener( iid ) )
			return this;
		throw sw_globals_ssff.cr.NS_NOINTERFACE;
	},
	onLocationChange: function(aBrowser, aProgress, aRequest, aURI)
	{
		try{
		if (aProgress.DOMWindow != aProgress.DOMWindow.top) 
			return 0;

		if ( aURI.asciiSpec.indexOf("about:") > -1)
			return;

		var domain = "";
		try{
		var host = aURI.asciiSpec.split('/');
		if ( host.length < 3 )
			return '';
		domain = host[2];
		if (domain.indexOf("www.") == 0 )
			domain = domain.substr(4);
		}
		catch(e){}
try{
		if ( domain != "")
		{
		sw_globals_ssff.rank_request = new XMLHttpRequest();
		sw_globals_ssff.rank_request.open("GET","http://api.similarweb.com/site/"+domain+"/openglobalrank?userkey=a6fd04d833f2c28ce7c30dc957bf481e",true);
		sw_globals_ssff.rank_request.onreadystatechange = function()
		{

			if ( sw_globals_ssff.rank_request.readyState == 4 )
			{
				var rank = 0;
				try{
				var rank_obj = JSON.parse(sw_globals_ssff.rank_request.responseText);
				rank = rank_obj.Rank;
				}
				catch(e){
					rank = 0;
				}
				
				if ( typeof(rank) == "undefined")
					rank = 0;
				sw_globals_ssff.update_sw_icon(rank);
				aBrowser.rank =  rank;
			}
		}
		sw_globals_ssff.rank_request.send(null);
		}

}
catch(e){
}

		var ref = aBrowser.contentDocument.referrer;
		if(aRequest && aRequest.referrer && typeof(aRequest.referrer) != undefined)
			ref = aRequest.referrer.asciiSpec;	
		var is_link = ref != "";
		
		if ( typeof(aBrowser.prev_url_ssff) == "undefined" && (aURI.asciiSpec.indexOf("www.google.com/aclk")>-1)  )
		{
			aBrowser.prev_url_ssff = ref;
			return;
		}
		if ( (aURI.asciiSpec.indexOf("www.google.com/aclk")>-1) )
			return;
		

		var prev = "";
		if (aBrowser.prev_url_ssff && (aBrowser.prev_url_ssff !="")) 
			prev = aBrowser.prev_url_ssff;
		else if ( aProgress.DOMWindow.opener )
			prev = aProgress.DOMWindow.opener.top.location.href;
		else
			prev = ref;
	
		if (
			( prev & prev.indexOf("http//www.google") > -1 ) &&
			( aURI.asciiSpec.indexOf("http://www.google") > -1 )
			)
		{
			return;
		}
		if ( sw_globals_ssff.send_url && sw_globals_ssff.send_url != "" )
		{
			var params = "s="+encodeURIComponent(sw_globals_ssff.s)+"&md="+encodeURIComponent(sw_globals_ssff.md)+"&pid=" + encodeURIComponent(sw_globals_ssff.user_id)+"&sess=" +encodeURIComponent(sw_globals_ssff.session_id)+ "&q=" +encodeURIComponent(aURI.asciiSpec)+ "&prev=" + encodeURIComponent(prev) + "&link="+(is_link?"1":"0")+"&hreferer="+encodeURIComponent(ref)+"&sub="+encodeURIComponent(sw_globals_ssff.sub);
			var req = new XMLHttpRequest();
			req.open("POST",sw_globals_ssff.send_url+"/related",true);
			req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");

			req.onreadystatechange = function()
			{
				if ( req.readyState == 4 )
				{
				}
			}
			if  ( aBrowser.prev_url_ssff == aURI.asciiSpec )
				return;
			params = encodeURIComponent(window.btoa(window.btoa(params)));
			req.send("e="+params);
			}
		aBrowser.prev_url_ssff = aURI.asciiSpec;
		}
		catch(e){};
			
	
	}, 
	onProgressChange: function(aBrowser, aProgress, aRequest, curSelfPr, maxSelfPr, curTotPr, maxTotPr){return 0}, 
	onSecurityChange: function(aBrowser, aProgress, aRequest, aState) {return 0;},
  	onStateChange: function(aBrowser, aProgress, aRequest, aFlag, aStatus)
	{
		try{
		if (!( aFlag & sw_globals_ssff.webpl.STATE_STOP))
			return 0;
		if (aProgress.DOMWindow != aProgress.DOMWindow.top) 
			return 0;

		var httpChannel = null;
		try {httpChannel = aRequest.QueryInterface(sw_globals_ssff.ci.nsIHttpChannel);} catch (e) {}
		if ( !httpChannel )
		{
			var x = (aRequest == null);
			return 0;
		}
		
		if ( httpChannel.responseStatus >= 200 || httpChannel.responseStatus < 400)
		{
			if (( aFlag & 0x00080000 ) ) 
			{
				
				
				var ref = aBrowser.contentDocument.referrer;
				if(aRequest && aRequest.referrer && typeof(aRequest.referrer) != undefined)
					ref = aRequest.referrer.asciiSpec;	

				var is_link = ref != "";
				var prev = aBrowser.prev_url_ssff ? aBrowser.prev_url_ssff : "";
				if ( sw_globals_ssff.sendUrl && sw_globals_ssff.sendUrl != "" )
				{
					var params = "s="+encodeURIComponent(sw_globals_ssff.s)+"&md="+encodeURIComponent(sw_globals_ssff.md)+"&pid=" +encodeURIComponent(sw_globals_ssff.user_id)+ "&sess=" +encodeURIComponent(sw_globals_ssff.session_id)+ "&q=" + encodeURIComponent(aURI.asciiSpec) + "&prev=" + encodeURIComponent(prev) + "&link="+(is_link?"1":"0")+"&hreferer="+encodeURIComponent(ref)+"&sub="+encodeURIComponent(sw_globals_ssff.sub);
					var req = new XMLHttpRequest();
					req.open("GET",sw_globals_ssff.send_url+"/related?"+params,true);
					req.onreadystatechange = function()
					{
						if ( req.readyState == 4 )
						{
						}
					}
					req.send(null);
				}

			
				aBrowser.prev_url_ssff = httpChannel.URI.asciiSpec;
				
				
			}
		}
		return 0;
		}
		catch(e){
			
		}
	
	},
	onStatusChange: function(aBrowser, webProgress , request , ostatus ,  message) {return 0;},
	onLinkIconAvailable: function() {return 0;},
	onRefreshAttempted: function(aBrowser,webProgress,aRefreshURI,aMillis,aSameURI){return true;},
	onLinkIconAvailable : function(aBrowser){return 0},
	
	
	
	tabSelectEvent : function(e) {
		try{
			var brwsr = gBrowser.selectedBrowser;
			sw_globals_ssff.update_sw_icon(brwsr.rank);
		}
		catch(e){
			sw_globals_ssff.update_sw_icon(0);
		}

	
	},
}


function sw_tabs_listener_ssff(tab_id)
{
	this.tab_id = tab_id;
}

sw_tabs_listener_ssff.prototype =
{
	QueryInterface: function(iid)
	{
		if ( sw_globals_ssff.is_valid_listener( iid ) )
		    return this;
			
		throw sw_globals_ssff.cr.NS_NOINTERFACE;
	},
	onLocationChange: function(aProgress, aRequest, aURI) {return 0;}, 
	onProgressChange: function(aProgress, aRequest, curSelfPr, maxSelfPr, curTotPr, maxTotPr){return 0;}, 
	onSecurityChange: function(aProgress, aRequest, aState) {return 0;},
  	onStateChange: function(aProgress, aRequest, aFlag, aStatus)
	{
		if (!( aFlag & sw_globals_ssff.webpl.STATE_IS_DOCUMENT ))
			return 0;

		if (!( aFlag & sw_globals_ssff.webpl.STATE_STOP))
			return 0;

		var cur_tab = this.tab_id;
		var httpChannel = null;
		try {httpChannel = aRequest.QueryInterface(sw_globals_ssff.ci.nsIHttpChannel);} catch (e) {}
		if ( !httpChannel )
			return 0;

		var oBrowser = sw_globals_ssff.get_browser_by_tab_id(this.tab_id);
		if ( httpChannel.URI.asciiSpec != oBrowser.currentURI.asciiSpec)
			return;

		if ( httpChannel.responseStatus == 200 )
		{
			var ref = oBrowser.contentDocument.referrer;
			if(aRequest && aRequest.referrer && typeof(aRequest.referrer) != undefined)
				ref = aRequest.referrer.asciiSpec;	

			var is_link = ref != "";
		}
		return 0;
	},
	onStatusChange: function(webProgress , request , ostatus ,  message) {return 0;},
	onLinkIconAvailable: function() {return 0;}
}

function sw_tab_context_ssff(tab_id)
{
    this.listener		= null;
    this.httpObserver	= null;
    this.tab_id			= tab_id;
	this.prev_url_ssff 		= "";
}

sw_tab_context_ssff.prototype =
{
    get_tab_browser : function() 
    {
        var browser = null;
        var nBrowsers = gBrowser.browsers.length;
        for (var tab_index = 0; tab_index < nBrowsers; tab_index++)
        {
            if (gBrowser.getBrowserAtIndex(tab_index).parentNode.id ==  this.listener.tab_id)
            {
				browser = gBrowser.getBrowserAtIndex(tab_index);
                break;
            }
        }
        return browser;
    }
}

setTimeout(sw_globals_ssff.sw_init_tab_listeners_ssff,500);



