//----------------------------------------------------------------------------------------
// Author: Stanislav.Shilo (shilo.stanislav.dmitrievich@gmail.com, skype: stanislav.shilo)
//----------------------------------------------------------------------------------------

var tab_url;
var similarweb_main = 
{
	renderHistoryList: function() 
	{
		try 
		{
            window.frames["SimilarWebFr"].location.reload();
		} 
		catch(e) 
		{
			return null;
		}
	},
	
    init: function()
	{
	    var navBar  = document.getElementById("nav-bar");
		if ( navBar.currentSet.indexOf("similarweb-add-list-button") == -1 )
		{
			var is_removed = 0;
			try{
				is_removed = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("").getCharPref("similarweb.buttonremoved");
			}
			catch(e){}
			if ( is_removed != '1')
				navBar.currentSet += ",similarweb-add-list-button"
		}
    },
    
    destroy: function()
	{
	    var navBar  = document.getElementById("nav-bar");
		if ( navBar.currentSet.indexOf("similarweb-add-list-button") == -1 )
			Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("").setCharPref("similarweb.buttonremoved","1");
    },
    
    currentURL: function()
	{
    },
};

var similar_web_popup = {
	clear : function()
	{
		document.getElementById("similarweb-dropdown").removeChild(document.getElementById("SimilarWebFr"))
		var ifr = document.createElement("iframe");
		ifr.setAttribute('src', 'chrome://similarweb/content/sw.html');
		ifr.style.width = "510px";
		ifr.style.height = "415px";
		ifr.id = "SimilarWebFr";
		document.getElementById("similarweb-dropdown").appendChild(ifr);
		
	}
}

window.addEventListener("load", function() { similarweb_main.init(); }, false); 
window.addEventListener("unload", function(){ similarweb_main.destroy(); }, false);