var swpopup = {
		Countries : {
        999: { name: "World", iso2: "WO" },
        4: { name: "Afghanistan", iso2: "AF" },
        8: { name: "Albania", iso2: "AL" },
        10: { name: "Antarctica", iso2: "AQ" },
        12: { name: "Algeria", iso2: "DZ" },
        16: { name: "American Samoa", iso2: "AS" },
        20: { name: "Andorra", iso2: "AD" },
        24: { name: "Angola", iso2: "AO" },
        28: { name: "Antigua and Barbuda", iso2: "AG" },
        31: { name: "Azerbaijan", iso2: "AZ" },
        32: { name: "Argentina", iso2: "AR" },
        36: { name: "Australia", iso2: "AU" },
        40: { name: "Austria", iso2: "AT" },
        44: { name: "Bahamas", iso2: "BS" },
        48: { name: "Bahrain", iso2: "BH" },
        50: { name: "Bangladesh", iso2: "BD" },
        51: { name: "Armenia", iso2: "AM" },
        52: { name: "Barbados", iso2: "BB" },
        56: { name: "Belgium", iso2: "BE" },
        60: { name: "Bermuda", iso2: "BM" },
        64: { name: "Bhutan", iso2: "BT" },
        68: { name: "Bolivia", iso2: "BO" },
        70: { name: "Bosnia", iso2: "BA" },
        72: { name: "Botswana", iso2: "BW" },
        74: { name: "Bouvet Island", iso2: "BV" },
        76: { name: "Brazil", iso2: "BR" },
        84: { name: "Belize", iso2: "BZ" },
        86: { name: "British Indian Territory", iso2: "IO" },
        90: { name: "Solomon Islands", iso2: "SB" },
        92: { name: "Virgin Islands", iso2: "VG" },
        96: { name: "Brunei", iso2: "BN" },
        100: { name: "Bulgaria", iso2: "BG" },
        104: { name: "Myanmar", iso2: "MM" },
        108: { name: "Burundi", iso2: "BI" },
        112: { name: "Belarus", iso2: "BY" },
        116: { name: "Cambodia", iso2: "KH" },
        120: { name: "Cameroon", iso2: "CM" },
        124: { name: "Canada", iso2: "CA" },
        132: { name: "Cape Verde", iso2: "CV" },
        136: { name: "Cayman Islands", iso2: "KY" },
        140: { name: "Central African", iso2: "CF" },
        144: { name: "Sri Lanka", iso2: "LK" },
        148: { name: "Chad", iso2: "TD" },
        152: { name: "Chile", iso2: "CL" },
        156: { name: "China", iso2: "CN" },
        158: { name: "Taiwan", iso2: "TW" },
        162: { name: "Christmas Island", iso2: "CX" },
        166: { name: "Cocos Islands", iso2: "CC" },
        170: { name: "Colombia", iso2: "CO" },
        174: { name: "Comoros", iso2: "KM" },
        175: { name: "Mayotte", iso2: "YT" },
        178: { name: "Congo", iso2: "CG" },
        180: { name: "Congo Republic", iso2: "CD" },
        184: { name: "Cook Islands", iso2: "CK" },
        188: { name: "Costa Rica", iso2: "CR" },
        191: { name: "Croatia", iso2: "HR" },
        192: { name: "Cuba", iso2: "CU" },
        196: { name: "Cyprus", iso2: "CY" },
        203: { name: "Czech Republic", iso2: "CZ" },
        204: { name: "Benin", iso2: "BJ" },
        208: { name: "Denmark", iso2: "DK" },
        212: { name: "Dominica", iso2: "DM" },
        214: { name: "Dominican Republic", iso2: "DO" },
        218: { name: "Ecuador", iso2: "EC" },
        222: { name: "El Salvador", iso2: "SV" },
        226: { name: "Equatorial Guinea", iso2: "GQ" },
        231: { name: "Ethiopia", iso2: "ET" },
        232: { name: "Eritrea", iso2: "ER" },
        233: { name: "Estonia", iso2: "EE" },
        234: { name: "Faroe Islands", iso2: "FO" },
        238: { name: "Falkland Islands (Malvinas)", iso2: "FK" },
        239: { name: "South Georgia Islands", iso2: "GS" },
        242: { name: "Fiji", iso2: "FJ" },
        246: { name: "Finland", iso2: "FI" },
        248: { name: "Aland Islands", iso2: "AX" },
        250: { name: "France", iso2: "FR" },
        254: { name: "French Guiana", iso2: "GF" },
        258: { name: "French Polynesia", iso2: "PF" },
        260: { name: "French Territories", iso2: "TF" },
        262: { name: "Djibouti", iso2: "DJ" },
        266: { name: "Gabon", iso2: "GA" },
        268: { name: "Georgia", iso2: "GE" },
        270: { name: "Gambia", iso2: "GM" },
        275: { name: "Palestinian", iso2: "PS" },
        276: { name: "Germany", iso2: "DE" },
        288: { name: "Ghana", iso2: "GH" },
        292: { name: "Gibraltar", iso2: "GI" },
        296: { name: "Kiribati", iso2: "KI" },
        300: { name: "Greece", iso2: "GR" },
        304: { name: "Greenland", iso2: "GL" },
        308: { name: "Grenada", iso2: "GD" },
        312: { name: "Guadeloupe", iso2: "GP" },
        316: { name: "Guam", iso2: "GU" },
        320: { name: "Guatemala", iso2: "GT" },
        324: { name: "Guinea", iso2: "GN" },
        328: { name: "Guyana", iso2: "GY" },
        332: { name: "Haiti", iso2: "HT" },
        334: { name: "Heard Islands", iso2: "HM" },
        336: { name: "Vatican City", iso2: "VA" },
        340: { name: "Honduras", iso2: "HN" },
        344: { name: "Hong Kong", iso2: "HK" },
        348: { name: "Hungary", iso2: "HU" },
        352: { name: "Iceland", iso2: "IS" },
        356: { name: "India", iso2: "IN" },
        360: { name: "Indonesia", iso2: "ID" },
        364: { name: "Iran", iso2: "IR" },
        368: { name: "Iraq", iso2: "IQ" },
        372: { name: "Ireland", iso2: "IE" },
        376: { name: "Israel", iso2: "IL" },
        380: { name: "Italy", iso2: "IT" },
        384: { name: "Cote d Ivoire", iso2: "CI" },
        388: { name: "Jamaica", iso2: "JM" },
        392: { name: "Japan", iso2: "JP" },
        398: { name: "Kazakhstan", iso2: "KZ" },
        400: { name: "Jordan", iso2: "JO" },
        404: { name: "Kenya", iso2: "KE" },
        408: { name: "Korea", iso2: "KP" },
        410: { name: "Korea Republic", iso2: "KR" },
        414: { name: "Kuwait", iso2: "KW" },
        417: { name: "Kyrgyzstan", iso2: "KG" },
        418: { name: "Lao", iso2: "LA" },
        422: { name: "Lebanon", iso2: "LB" },
        426: { name: "Lesotho", iso2: "LS" },
        428: { name: "Latvia", iso2: "LV" },
        430: { name: "Liberia", iso2: "LR" },
        434: { name: "Libyan", iso2: "LY" },
        438: { name: "Liechtenstein", iso2: "LI" },
        440: { name: "Lithuania", iso2: "LT" },
        442: { name: "Luxembourg", iso2: "LU" },
        446: { name: "Macao", iso2: "MO" },
        450: { name: "Madagascar", iso2: "MG" },
        454: { name: "Malawi", iso2: "MW" },
        458: { name: "Malaysia", iso2: "MY" },
        462: { name: "Maldives", iso2: "MV" },
        466: { name: "Mali", iso2: "ML" },
        470: { name: "Malta", iso2: "MT" },
        474: { name: "Martinique", iso2: "MQ" },
        478: { name: "Mauritania", iso2: "MR" },
        480: { name: "Mauritius", iso2: "MU" },
        484: { name: "Mexico", iso2: "MX" },
        492: { name: "Monaco", iso2: "MC" },
        496: { name: "Mongolia", iso2: "MN" },
        498: { name: "Moldova", iso2: "MD" },
        499: { name: "Montenegro", iso2: "ME" },
        500: { name: "Montserrat", iso2: "MS" },
        504: { name: "Morocco", iso2: "MA" },
        508: { name: "Mozambique", iso2: "MZ" },
        512: { name: "Oman", iso2: "OM" },
        516: { name: "Namibia", iso2: "NA" },
        520: { name: "Nauru", iso2: "NR" },
        524: { name: "Nepal", iso2: "NP" },
        528: { name: "Netherlands", iso2: "NL" },
        530: { name: "Netherlands Antilles", iso2: "AN" },
        533: { name: "Aruba", iso2: "AW" },
        540: { name: "New Caledonia", iso2: "NC" },
        548: { name: "Vanuatu", iso2: "VU" },
        554: { name: "New Zealand", iso2: "NZ" },
        558: { name: "Nicaragua", iso2: "NI" },
        562: { name: "Niger", iso2: "NE" },
        566: { name: "Nigeria", iso2: "NG" },
        570: { name: "Niue", iso2: "NU" },
        574: { name: "Norfolk Island", iso2: "NF" },
        578: { name: "Norway", iso2: "NO" },
        580: { name: "Northern Mariana Islands", iso2: "MP" },
        581: { name: "United States Outlying Islands", iso2: "UM" },
        583: { name: "Micronesia", iso2: "FM" },
        584: { name: "Marshall Islands", iso2: "MH" },
        585: { name: "Palau", iso2: "PW" },
        586: { name: "Pakistan", iso2: "PK" },
        591: { name: "Panama", iso2: "PA" },
        598: { name: "Papua New Guinea", iso2: "PG" },
        600: { name: "Paraguay", iso2: "PY" },
        604: { name: "Peru", iso2: "PE" },
        608: { name: "Philippines", iso2: "PH" },
        612: { name: "Pitcairn", iso2: "PN" },
        616: { name: "Poland", iso2: "PL" },
        620: { name: "Portugal", iso2: "PT" },
        624: { name: "Guinea-Bissau", iso2: "GW" },
        626: { name: "Timor-Leste", iso2: "TL" },
        630: { name: "Puerto Rico", iso2: "PR" },
        634: { name: "Qatar", iso2: "QA" },
        638: { name: "Reunion", iso2: "RE" },
        642: { name: "Romania", iso2: "RO" },
        643: { name: "Russian Federation", iso2: "RU" },
        646: { name: "Rwanda", iso2: "RW" },
        652: { name: "Saint Barthelemy", iso2: "BL" },
        654: { name: "Saint Helena ", iso2: "SH" },
        659: { name: "Saint Kitts and Nevis", iso2: "KN" },
        660: { name: "Anguilla", iso2: "AI" },
        662: { name: "Saint Lucia", iso2: "LC" },
        663: { name: "Saint Martin (French part)", iso2: "MF" },
        666: { name: "Saint Pierre and Miquelon", iso2: "PM" },
        670: { name: "Saint Vincent", iso2: "VC" },
        674: { name: "San Marino", iso2: "SM" },
        678: { name: "Sao Tome and Principe", iso2: "ST" },
        682: { name: "Saudi Arabia", iso2: "SA" },
        686: { name: "Senegal", iso2: "SN" },
        688: { name: "Serbia", iso2: "RS" },
        690: { name: "Seychelles", iso2: "SC" },
        694: { name: "Sierra Leone", iso2: "SL" },
        702: { name: "Singapore", iso2: "SG" },
        703: { name: "Slovakia", iso2: "SK" },
        704: { name: "Viet Nam", iso2: "VN" },
        705: { name: "Slovenia", iso2: "SI" },
        706: { name: "Somalia", iso2: "SO" },
        710: { name: "South Africa", iso2: "ZA" },
        716: { name: "Zimbabwe", iso2: "ZW" },
        724: { name: "Spain", iso2: "ES" },
        732: { name: "Western Sahara", iso2: "EH" },
        736: { name: "Sudan", iso2: "SD" },
        740: { name: "Suriname", iso2: "SR" },
        744: { name: "Svalbard and Jan Mayen", iso2: "SJ" },
        748: { name: "Swaziland", iso2: "SZ" },
        752: { name: "Sweden", iso2: "SE" },
        756: { name: "Switzerland", iso2: "CH" },
        760: { name: "Syrian Arab Republic", iso2: "SY" },
        762: { name: "Tajikistan", iso2: "TJ" },
        764: { name: "Thailand", iso2: "TH" },
        768: { name: "Togo", iso2: "TG" },
        772: { name: "Tokelau", iso2: "TK" },
        776: { name: "Tonga", iso2: "TO" },
        780: { name: "Trinidad and Tobago", iso2: "TT" },
        784: { name: "United Arab Emirates", iso2: "AE" },
        788: { name: "Tunisia", iso2: "TN" },
        792: { name: "Turkey", iso2: "TR" },
        795: { name: "Turkmenistan", iso2: "TM" },
        796: { name: "Turks and Caicos Islands", iso2: "TC" },
        798: { name: "Tuvalu", iso2: "TV" },
        800: { name: "Uganda", iso2: "UG" },
        804: { name: "Ukraine", iso2: "UA" },
        807: { name: "Macedonia", iso2: "MK" },
        818: { name: "Egypt", iso2: "EG" },
        826: { name: "United Kingdom", iso2: "GB" },
        831: { name: "Guernsey", iso2: "GG" },
        832: { name: "Jersey", iso2: "JE" },
        833: { name: "Isle of Man", iso2: "IM" },
        834: { name: "Tanzania", iso2: "TZ" },
        840: { name: "United States", iso2: "US" },
        850: { name: "Virgin Islands, U.S.", iso2: "VI" },
        854: { name: "Burkina Faso", iso2: "BF" },
        858: { name: "Uruguay", iso2: "UY" },
        860: { name: "Uzbekistan", iso2: "UZ" },
        862: { name: "Venezuela", iso2: "VE" },
        876: { name: "Wallis and Futuna", iso2: "WF" },
        882: { name: "Samoa", iso2: "WS" },
        887: { name: "Yemen", iso2: "YE" },
        891: { name: "SERBIA Republic", iso2: "CS" },
        894: { name: "Zambia", iso2: "ZM" },
        900: { name: "European Union", iso2: "EU" },
        901: { name: "Non-spec Asia Location", iso2: "AP" },
        902: { name: "Reserved", iso2: "ZZ" }
		},
		api_baseurl : "http://api.similarweb.com/site/",
		get_user_key : function() {return "a6fd04d833f2c28ce7c30dc957bf481e";},
		current_site : '',
		format_number : function(num)
		{
			num = num.toString();
			var pattern = /(-?\d+)(\d{3})/;
			while (pattern.test(num))
				num = num.replace(pattern, "$1,$2");
			return num;		
		},
		get_current_site : function() {
			return swpopup.current_site;
		},
		get_domain_from_url : function(url){
			try{
			if ( url == null )
				return;
			var host = url.split('/');
			if ( host.length < 3 )
				return '';
			var domain = host[2];
			if (domain.indexOf("www.") == 0 )
				domain = domain.substr(4);
			return domain;	
				
			}catch(e){return '';}
		},
		add_data_to_ui : function(domain,data)
		{
			$("#loading").css("display", "none");
			$("#content").css("display", "block"); 
			$('#current_site_text').text(domain);
			var count = 0;
			$('#related_sites').text("");
			for ( i in data.SimilarSites )
			{
				var url = data.SimilarSites[i].Url.toLowerCase();
				var tmp = url[0].toUpperCase() + url.substring(1);
				if ( tmp.indexOf("/") > -1 )
					tmp = tmp.substring(0,tmp.indexOf("/"));
				
				$('<div/>', {id: 'similarsite'+i,class:'siterow',domain:tmp,favicon:data.SimilarSites[i].FavIcon}).appendTo('#related_sites').click(function(){
						swpopup.gotosimilarweb($(this).attr('domain'));
				});
				$('<span />',{id:"similarsiteimg"+i,class:"similarsiteimg"}).appendTo('#similarsite'+i);
				$('<img/>', {id: 'similarflag'+i,border:"0px",src:data.SimilarSites[i].FavIcon,width:"16px",height:"16px"}).addClass("favicon").appendTo('#similarsiteimg'+i);
				$('<span/>', {id: 'similarsitename'+i,text:tmp}).css({"padding-left":"10px"}).appendTo('#similarsite'+i);
				count++;
				if ( count == 10 )
					break;;
			}

			$('#favicon_self').attr("src",data.FavIcon);
			if ( data.GlobalRank > 0 )
				$('#GlobalRankValue').text(swpopup.format_number(data.GlobalRank));
			else
				$('#GlobalRankValue').text("N/A");
			if ( data.CountryRank > 0 )
				$('#CountryRankValue').text(swpopup.format_number(data.CountryRank));
			else
				$('#CountryRankValue').text("N/A");

			if ( data.CategoryRank > 0 )
				$('#CategoryRankValue').text(swpopup.format_number(data.CategoryRank));
			else
				$('#CategoryRankValue').text("N/A");

			
			var subTitle = data.Category;
			subTitle = subTitle.replace("_"," ");
			subTitle = subTitle.replace("/"," > ");
			
			var cat_link = data.Category;
			cat_link = cat_link.replace("/","~");
			cat_link = cat_link.replace("/","~");
			
			$('#CategorySubTitle').attr("category", cat_link);
			$('#CategorySubTitle').text(subTitle).click(function(){
				swpopup.open_page_in_new_tab("http://www.similarweb.com/category/"+$(this).attr('category')+"/top100");
			});
			
			
			try{
			var avgTrafficReach = data.LastAvgTrafficReach*100;
			avgTrafficReach = (""+avgTrafficReach).substr(0,4)+"%";
			$('#TrafficReachValue').text(avgTrafficReach).css({"padding-left":"10px"});
			var countryName = '';
			var countryClass = '';
			try{
				countryName = swpopup.Countries[data.Country].name.toUpperCase();
				countryClass = swpopup.Countries[data.Country].iso2.toLowerCase();
			} catch(e){}

			$(CountryRankImg).removeClass().addClass("flag").addClass("small").addClass(countryClass);
			$("#CountrySubTitle").attr("cname",swpopup.Countries[data.Country].name);
			$("#CountrySubTitle").text(countryName).click(function(){
				swpopup.open_page_in_new_tab("http://www.similarweb.com/country/"+$("#CountrySubTitle").attr("cname")+"/top100");
			});
			var className = data.Category;//.toLowerCase();
			var offset = className.indexOf("/");

			if ( offset > -1 )
				className = className.substr(0,offset);
			className = className.replace(" ","_");
			$('#CategoryRankImg').removeClass().addClass("categories").addClass(className);
			}catch(e){}
			var trendValues = new Array();
			$("#TrafficReachImg").sparkline(data.TrafficReach, {type: 'line',lineColor: '#7f7f7f',fillColor:'#f0f0f0',width:'60px',height:'20x',normalRangeMin: 0});
			swpopup.generate_chart(data.TrafficShares);
			if ( $('#CategoryRank').height() >60)
			{
				$('#TrafficReach').css({"min-height":"35px"}).height(35);
				$('#GlobalRank').css({"min-height":"40px"}).height(45);
			}
			
		},
		generate_chart : function(data)
		{
			var direct = data.Direct*100;
			direct = direct.toFixed(1);
			var search = data.Search*100;
			search = search.toFixed(1);
			var social = data.Social*100;
			social = social.toFixed(1);
			var mail = data.Mail*100;
			mail = mail.toFixed(1);
			var ads = data["Paid Referrals"]*100;
			ads = ads.toFixed(1);
			var refs = data.Referrals*100;
			refs = refs.toFixed(1);

			addColumn(0,direct , "Direct"); 
			addColumn(0, search, "Traffic-search");
			addColumn(0, social, "Social"); 
			addColumn(0, mail, "Mail"); 
			addColumn(0, ads, "Display-ads"); 
			addColumn(0, refs, "Referrals");

		},
		get_current_site_data : function(site_url)
		{
			swpopup.current_site = site_url;
			var domain		= swpopup.get_domain_from_url(swpopup.current_site);
			var action 		= "rankoverview";
			var params 		= "userkey="+swpopup.get_user_key();
			return swpopup.get_domain_data(domain,action,params);
		},
		get_domain_data : function(domain,action,params){
		if ( domain == "" )
			return;
		$.ajax({
			url:  swpopup.api_baseurl+encodeURIComponent(domain)+"/"+action,
			data: params,
			type: "GET",
			timeout: 30000,
			dataType: "json", // "xml", "json"
			success: function(val) {
				swpopup.add_data_to_ui(domain,val);
			},
			error: function(jqXHR, textStatus, ex) {
			 $("#loading").css("display", "none");
              $("#content").css("display","none");
              $("#error_page").css("display","block");
			}
		});
		
		},
		open_page_in_new_tab : function(url)
		{
			var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)  
                       .getInterface(Components.interfaces.nsIWebNavigation)  
                       .QueryInterface(Components.interfaces.nsIDocShellTreeItem)  
                       .rootTreeItem  
                       .QueryInterface(Components.interfaces.nsIInterfaceRequestor)  
                       .getInterface(Components.interfaces.nsIDOMWindow);  
  
			mainWindow.gBrowser.selectedTab = mainWindow.gBrowser.addTab(url);  
			//alert(mainWindow.gBrowser.ownerDocument.defaultView);//.defaultView.focus();
			//var x = mainWindow.gBrowser.ownerDocument.children;
			mainWindow.gBrowser.ownerDocument.getElementById("similarweb-dropdown").hidePopup();
		
		},
		gotosimilarweb : function(domain)
		{
			if ( typeof(domain) == "undefined")
			{
				domain = swpopup.get_current_site();
				domain	= swpopup.get_domain_from_url(domain);
				swpopup.open_page_in_new_tab("http://www.similarweb.com/website/"+domain);
				return;
			}

			swpopup.open_page_in_new_tab("http://"+domain);
		}
		
};


var chart = $("body").find(".chart");


function formattedPercentage (value) {
    return (value * 100).toFixed(2);
}

function addColumn(slot, data, where) {

 var _where = $("body").find(".chart").find(".column." + where).find(".graph");
        var _series = $("<div class='series'></div>");
        var _label = $("<span class='label slot'></span>");
        var _percentage = data;
        var _seriesCount;

        _series.css("height", (parseFloat(_percentage) <= 1.0) ? 1.0 : _percentage + "%");
        _series.css("margin-top", 100 - _series.height());
        _series.addClass("slot" + slot);


        _series.data("slot", slot);

        _label.html(_percentage + "%");
        _label.addClass("slot" + slot);

        if (parseFloat(_percentage) >= 65) {
            _label.addClass("high");
            _label.css("margin-bottom", "0");
        }

        _where.append(_series);
        _where.append(_label);
        _where.addClass("size1Of1");

        try {
            _label.css("left", _where.find(".slot" + slot).position().left);
            _label.data("slot", slot);
            _label.css("bottom", _where.find(".slot" + slot).height() + 4 + "px");

            if (_label.hasClass("high")) {
                _label.css("bottom", "5px");
            }

            $(window).trigger("resize");
        }
        catch (ex) {
        }
}
		
		var currentWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser");
		var currBrowser = currentWindow.getBrowser();
		var currURL = currBrowser.currentURI.spec;
		swpopup.get_current_site_data(currURL);
